/*
								+----------------------------------+
								|                                  |
								|    ***  Bit array class   ***    |
								|                                  |
								|   Copyright  -tHE SWINe- 2005   |
								|                                  |
								|            BitArray.h            |
								|                                  |
								+----------------------------------+
*/

#ifndef __BIT_ARRAY_INCLUDED
#define __BIT_ARRAY_INCLUDED

class CBitArray;

class CBit {
protected:
	CBitArray *m_p_array;
	int m_n_my_index;

public:
	CBit(CBitArray *p_array, int n_index) :m_p_array(p_array), m_n_my_index(n_index) {}

	inline bool operator =(bool b_value);
	inline operator bool() const;
};

class CBitArray {
protected:
	unsigned int *m_p_array;
	int m_n_array_size;
	int m_n_array_used;

public:
	CBitArray();
	CBitArray(int n_length);
	~CBitArray();

	bool Alloc(int n_length);
	bool Extend(int n_length);
	bool Free();
	int n_Length() const; // length in !! bits !!

	CBit __fastcall operator [](int n_index);
	const CBit __fastcall operator [](int n_index) const; // single bit access

	bool operator =(bool b_value);
	bool operator =(const CBitArray &r_array);
	bool operator +=(const CBitArray &r_array); // whole array assign

	bool operator ==(bool b_value);
	int operator ==(const CBitArray &r_array); // whole array compare

	void Set_Array(bool b_value);
	void __fastcall Set_Bit(int n_index, bool b_value);
	bool __fastcall b_Get_Bit(int n_index) const;
	void __fastcall Set_Bit_High(int n_index);
	void __fastcall Set_Bit_Low(int n_index); // core (fast) functions exposed

	bool Store(FILE *p_fw) const;
	bool Load(FILE *p_fr);

	static unsigned int pow2(int x); // power of two
};

/*
 *								=== CBit inline ===
 */

bool CBit::operator =(bool b_value)
{
	m_p_array->Set_Bit(m_n_my_index, b_value);
	return m_p_array->b_Get_Bit(m_n_my_index);
}

CBit::operator bool() const
{
	return m_p_array->b_Get_Bit(m_n_my_index);
}

/*
 *								=== ~CBit inline ===
 */

#endif //__BIT_ARRAY_INCLUDED
