/*
								+---------------------------------+
								|                                 |
								|  ***   Lame common dlgs   ***  |
								|                                 |
								|  Copyright   -tHE SWINe- 2005  |
								|                                 |
								|            Dialogs.h            |
								|                                 |
								+---------------------------------+
*/

/*
 *	passed code revision at 11-13-2006
 *
 *	all integers, containing just true or false were replaced by bool
 *	added bool CLoggerDialog::AddLineF(const char *p_s_format_str, ...) function
 *	added function-documenting comments (todo)
 *	note it's possible to use GetModuleHandle(NULL) in DLL mode
 *
 */

#ifndef __LAME_COMDLGS_INCLUDED
#define __LAME_COMDLGS_INCLUDED

#ifndef __UBERLAME_DLL
#define __declspec(x) 
// in case we're not compiling dll, we don't want to export anything
#endif

class __declspec(dllexport) CLameDialog {
protected:
	static std::vector<CLameDialog*> *m_p_dialog_list;
	static CLameDialog *m_p_recent_dialog;
	static CLameDialog *m_p_dialog_being_created;

	HWND m_h_dlg;
	int m_n_resource_id;

	bool m_b_being_destroyed; // some glitches with messages sent after EndDialog()

public:
	CLameDialog(int n_resource_id);
	~CLameDialog();

	bool Create(HWND h_parent, HINSTANCE h_instance); // can use GetModuleHandle(NULL); to obtain h_instance
	bool End();

	void SetFocus() { if(b_Created()) ::SetFocus(m_h_dlg); }

	bool b_Created();

protected:
	static int CALLBACK GlobalDlgProc(HWND h_dlg, unsigned int n_msg,
		unsigned int n_w_param, long n_l_param);
	virtual int DlgProc(HWND h_dlg, unsigned int n_msg,
		unsigned int n_w_param, long n_l_param) = 0;
};

class __declspec(dllexport) CLoggerDialog : public CLameDialog {
protected:
	int m_n_max_lines;

public:
	CLoggerDialog() :CLameDialog(IDD_LOGWINDOW), m_n_max_lines(256) {}

	void Set_MaxLines(int n_max_lines) { m_n_max_lines = n_max_lines; }

	bool AddLine(const char *p_s_str);
	bool AddLineF(const char *p_s_format_str, ...);

protected:
	virtual int DlgProc(HWND h_dlg, unsigned int n_msg,
		unsigned int n_w_param, long n_l_param);
};

class __declspec(dllexport) CRenderPathDialog : public CLameDialog {
protected:
	bool m_b_clicked_ok;
	HWND m_h_listbox;

public:
	CRenderPathDialog() :CLameDialog(IDD_PATH_PICKER) {}

	bool AddPath(const char *p_s_name, int n_supported_materials, int n_materials);
	bool SelectPath(const char *p_s_name);
	bool ShaderLang(int n_lang_switch, bool b_arb_support, bool b_glsl_support);
	bool CompressTextures(bool b_compress_textures);

	bool Create(HWND h_parent, HINSTANCE h_instance);

	bool DoModal(int &r_n_chosen_path, bool &r_b_set_default,
		int &r_n_lang_switch, bool &r_b_compress_textures);

protected:
	virtual int DlgProc(HWND h_dlg, unsigned int n_msg,
		unsigned int n_w_param, long n_l_param);
};

#endif //__LAME_COMDLGS_INCLUDED
