/*
								+----------------------------------+
								|                                  |
								|   ***  Stroke font-engine  ***   |
								|                                  |
								|   Copyright  -tHE SWINe- 2003   |
								|                                  |
								|           StrokeFont.h           |
								|                                  |
								+----------------------------------+
*/

#ifndef __FONTENG_INCLUDED
#define __FONTENG_INCLUDED

class CFont {
public:
	virtual int Load(const char *p_s_font_name, CGLState *p_state) = 0;
	virtual void Free() = 0;

	virtual void Zoom(float f_new_size = 1) = 0;
	virtual float f_Zoom() const = 0;

	virtual void Plot_Character(CGLState *p_state, Vector2f v_pos, char c_char) const = 0;
	virtual void Plot_String(CGLState *p_state, Vector2f v_pos,
		const char *p_s_string, int n_length = -1) const = 0;

	virtual float f_StringWidth(const char *p_s_string, int n_length = -1) const = 0;
	virtual Vector2f v_CharacterOffset(const char *p_s_string, int n_length) const = 0;
};

#endif // __FONTENG_INCLUDED

#ifndef __STROKE_ENG_INCLUDED
#define __STROKE_ENG_INCLUDED

struct TStrokeChar;

class CStrokeFont : public CFont {
	int m_n_char_num;
	TStrokeChar *m_p_char;
	int m_n_lookup[256];

	int m_b_space_style;

	float m_f_side_ratio;
	float m_f_cur_size;

	float m_f_space_shift;
	float m_f_grid_height;

public:
	CStrokeFont();
	virtual ~CStrokeFont();

	virtual int Load(const char *p_filename, CGLState *p_state);
	virtual void Free();

	virtual void Zoom(float f_new_size = 1);
	virtual float f_Zoom() const { return m_f_cur_size; }

	virtual void Plot_Character(CGLState *p_state, Vector2f v_pos, char c_char) const;
	virtual void Plot_String(CGLState *p_state, Vector2f v_pos, const char *s_string, int n_length = -1) const;

	virtual float f_StringWidth(const char *p_s_string, int n_length = -1) const;
	virtual Vector2f v_CharacterOffset(const char *p_s_string, int n_length) const;
};

#endif //__STROKE_ENG_INCLUDED
